---
title: Debugger.Object
slug: Tools/Debugger-API/Debugger.Object
---
<div>{{ToolsSidebar}}</div>

<h1 id="Debugger.Object">Debugger.Object</h1>

<p>A <code>Debugger.Object</code> instance represents an object in the debuggee, providing reflection-oriented methods to inspect and modify its referent. The referent’s properties do not appear directly as properties of the <code>Debugger.Object</code> instance; the debugger can access them only through methods like <code>Debugger.Object.prototype.getOwnPropertyDescriptor</code> and <code>Debugger.Object.prototype.defineProperty</code>, ensuring that the debugger will not inadvertently invoke the referent’s getters and setters.</p>

<p>SpiderMonkey creates exactly one <code>Debugger.Object</code> instance for each debuggee object it presents to a given <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance: if the debugger encounters the same object through two different routes (perhaps two functions are called on the same object), SpiderMonkey presents the same <code>Debugger.Object</code> instance to the debugger each time. This means that the debugger can use the <code>==</code> operator to recognize when two <code>Debugger.Object</code> instances refer to the same debuggee object, and place its own properties on a <code>Debugger.Object</code> instance to store metadata about particular debuggee objects.</p>

<p>JavaScript code in different compartments can have different views of the same object. For example, in Firefox, code in privileged compartments sees content DOM element objects without redefinitions or extensions made to that object’s properties by content code. (In Firefox terminology, privileged code sees the element through an “xray wrapper”.) To ensure that debugger code sees each object just as the debuggee would, each <code>Debugger.Object</code> instance presents its referent as it would be seen from a particular compartment. This “viewing compartment” is chosen to match the way the debugger came across the referent. As a consequence, a single <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance may actually have several <code>Debugger.Object</code> instances: one for each compartment from which the referent is viewed.</p>

<p>If more than one <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance is debugging the same code, each <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> gets a separate <code>Debugger.Object</code> instance for a given object. This allows the code using each <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance to place whatever properties it likes on its own <code>Debugger.Object</code> instances, without worrying about interfering with other debuggers.</p>

<p>While most <code>Debugger.Object</code> instances are created by SpiderMonkey in the process of exposing debuggee’s behavior and state to the debugger, the debugger can use <code>Debugger.Object.prototype.makeDebuggeeValue</code> to create <code>Debugger.Object</code> instances for given debuggee objects, or use <code>Debugger.Object.prototype.copy</code> and <code>Debugger.Object.prototype.create</code> to create new objects in debuggee compartments, allocated as if by particular debuggee globals.</p>

<p><code>Debugger.Object</code> instances protect their referents from the garbage collector; as long as the <code>Debugger.Object</code> instance is live, the referent remains live. This means that garbage collection has no visible effect on <code>Debugger.Object</code> instances.</p>

<h2 id="Accessor_Properties_of_the_Debugger.Object_prototype">Accessor Properties of the Debugger.Object prototype</h2>

<p>A <code>Debugger.Object</code> instance inherits the following accessor properties from its prototype:</p>

<dl>
 <dt><code>proto</code></dt>
 <dd>The referent’s prototype (as a new <code>Debugger.Object</code> instance), or <code>null</code> if it has no prototype. This accessor may throw if the referent is a scripted proxy or some other sort of exotic object (an opaque wrapper, for example).</dd>
 <dt><code>class</code></dt>
 <dd>A string naming the ECMAScript <code>[[Class]]</code> of the referent.</dd>
 <dt><code>callable</code></dt>
 <dd><code>true</code> if the referent is a callable object (such as a function or a function proxy); false otherwise.</dd>
 <dt><code>name</code></dt>
 <dd>
 <p>The name of the referent, if it is a named function. If the referent is an anonymous function, or not a function at all, this is <code>undefined</code>.</p>

 <p>This accessor returns whatever name appeared after the <code>function</code> keyword in the source code, regardless of whether the function is the result of instantiating a function declaration (which binds the function to its name in the enclosing scope) or evaluating a function expression (which binds the function to its name only within the function’s body).</p>
 </dd>
 <dt><code>displayName</code></dt>
 <dd>
 <p>The referent’s display name, if the referent is a function with a display name. If the referent is not a function, or if it has no display name, this is <code>undefined</code>.</p>

 <p>If a function has a given name, its display name is the same as its given name. In this case, the <code>displayName</code> and <code>name</code> properties are equal.</p>

 <p>If a function has no name, SpiderMonkey attempts to infer an appropriate name for it given its context. For example:</p>

 <pre class="language-js"><code>function f() {}          // display name: f (the given name)
var g = function () {};  // display name: g
o.p = function () {};    // display name: o.p
var q = {
  r: function () {}      // display name: q.r
};</code></pre>

 <p>Note that the display name may not be a proper JavaScript identifier, or even a proper expression: we attempt to find helpful names even when the function is not immediately assigned as the value of some variable or property. Thus, we use <code><em>a</em>/<em>b</em></code> to refer to the<em>b</em> defined within<em>a</em>, and <code><em>a</em>&lt;</code> to refer to a function that occurs somewhere within an expression that is assigned to<em>a</em>. For example:</p>

 <pre class="language-js"><code>function h() {
  var i = function() {};    // display name: h/i
  f(function () {});        // display name: h/&lt;
}
var s = f(function () {});  // display name: s&lt;</code></pre>
 </dd>
 <dt><code>parameterNames</code></dt>
 <dd>
 <p>If the referent is a debuggee function, the names of the its parameters, as an array of strings. If the referent is not a debuggee function, or not a function at all, this is <code>undefined</code>.</p>

 <p>If the referent is a host function for which parameter names are not available, return an array with one element per parameter, each of which is <code>undefined</code>.</p>

 <p>If the referent is a function proxy, return an empty array.</p>

 <p>If the referent uses destructuring parameters, then the array’s elements reflect the structure of the parameters. For example, if the referent is a function declared in this way:</p>

 <pre class="language-js"><code>function f(a, [b, c], {d, e:f}) { ... }</code></pre>

 <p>then this <code>Debugger.Object</code> instance’s <code>parameterNames</code> property would have the value:</p>

 <pre class="language-js"><code>["a", ["b", "c"], {d:"d", e:"f"}]</code></pre>
 </dd>
 <dt><code>script</code></dt>
 <dd>If the referent is a function that is debuggee code, this is that function’s script, as a <a href="Debugger.Script"><code>Debugger.Script</code></a> instance. If the referent is a function proxy or not debuggee code, this is <code>undefined</code>.</dd>
 <dt><code>environment</code></dt>
 <dd>If the referent is a function that is debuggee code, a <a href="Debugger.Environment"><code>Debugger.Environment</code></a> instance representing the lexical environment enclosing the function when it was created. If the referent is a function proxy or not debuggee code, this is <code>undefined</code>.</dd>
 <dt><code>errorMessageName</code></dt>
 <dd>If the referent is an error created with an engine internal message template this is a string which is the name of the template; <code>undefined</code> otherwise.</dd>
 <dt><code>errorLineNumber</code></dt>
 <dd>If the referent is an Error object, this is the line number at which the referent was created; <code>undefined</code> otherwise.</dd>
 <dt><code>errorColumnNumber</code></dt>
 <dd>If the referent is an Error object, this is the column number at which the referent was created; <code>undefined</code> otherwise.</dd>
 <dt><code>isBoundFunction</code></dt>
 <dd>If the referent is a debuggee function, returns <code>true</code> if the referent is a bound function; <code>false</code> otherwise. If the referent is not a debuggee function, or not a function at all, returns <code>undefined</code> instead.</dd>
 <dt><code>isArrowFunction</code></dt>
 <dd>If the referent is a debuggee function, returns <code>true</code> if the referent is an arrow function; <code>false</code> otherwise. If the referent is not a debuggee function, or not a function at all, returns <code>undefined</code> instead.</dd>
 <dt><code>isGeneratorFunction</code></dt>
 <dd>If the referent is a debuggee function, returns <code>true</code> if the referent was created with a <code>function*</code> expression or statement, or false if it is some other sort of function. If the referent is not a debuggee function, or not a function at all, this is <code>undefined</code>. (This is always equal to <code>obj.script.isGeneratorFunction</code>, assuming <code>obj.script</code> is a <code>Debugger.Script</code>.)</dd>
 <dt><code>isAsyncFunction</code></dt>
 <dd>If the referent is a debuggee function, returns <code>true</code> if the referent is an async function, defined with an <code>async function</code> expression or statement, or false if it is some other sort of function. If the referent is not a debuggee function, or not a function at all, this is <code>undefined</code>. (This is always equal to <code>obj.script.isAsyncFunction</code>, assuming <code>obj.script</code> is a <code>Debugger.Script</code>.)</dd>
 <dt><code>isPromise</code></dt>
 <dd><code>true</code> if the referent is a Promise; <code>false</code> otherwise.</dd>
 <dt><code>boundTargetFunction</code></dt>
 <dd>If the referent is a bound debuggee function, this is its target function— the function that was bound to a particular <code>this</code> object. If the referent is either not a bound function, not a debuggee function, or not a function at all, this is <code>undefined</code>.</dd>
 <dt><code>boundThis</code></dt>
 <dd>If the referent is a bound debuggee function, this is the <code>this</code> value it was bound to. If the referent is either not a bound function, not a debuggee function, or not a function at all, this is <code>undefined</code>.</dd>
 <dt><code>boundArguments</code></dt>
 <dd>If the referent is a bound debuggee function, this is an array (in the Debugger object’s compartment) that contains the debuggee values of the <code>arguments</code> object it was bound to. If the referent is either not a bound function, not a debuggee function, or not a function at all, this is <code>undefined</code>.</dd>
 <dt><code>isProxy</code></dt>
 <dd>If the referent is a (scripted) proxy, either revoked or not, return <code>true</code>. If the referent is not a (scripted) proxy, return <code>false</code>.</dd>
 <dt><code>proxyTarget</code></dt>
 <dd>If the referent is a non-revoked (scripted) proxy, return a <code>Debugger.Object</code> instance referring to the ECMAScript <code>[[ProxyTarget]]</code> of the referent. If the referent is a revoked (scripted) proxy, return <code>null</code>. If the referent is not a (scripted) proxy, return <code>undefined</code>.</dd>
 <dt><code>proxyHandler</code></dt>
 <dd>If the referent is a non-revoked (scripted) proxy, return a <code>Debugger.Object</code> instance referring to the ECMAScript <code>[[ProxyHandler]]</code> of the referent. If the referent is a revoked (scripted) proxy, return <code>null</code>. If the referent is not a (scripted) proxy, return <code>undefined</code>.</dd>
 <dt><code>promiseState</code></dt>
 <dd>
 <p>If the referent is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, return a string indicating whether the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> is pending, or has been fulfilled or rejected. This string takes one of the following values:</p>

 <ul>
  <li>
   <p><code>"pending"</code>, if the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> is pending.</p>
  </li>
  <li>
   <p><code>"fulfilled"</code>, if the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> has been fulfilled.</p>
  </li>
  <li>
   <p><code>"rejected"</code>, if the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> has been rejected.</p>
  </li>
 </ul>

 <p>If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>promiseValue</code></dt>
 <dd>
 <p>Return a debuggee value representing the value the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> has been fulfilled with.</p>

 <p>If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, or the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> has not been fulfilled, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>promiseReason</code></dt>
 <dd>
 <p>Return a debuggee value representing the value the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> has been rejected with.</p>

 <p>If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, or the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> has not been rejected, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>promiseAllocationSite</code></dt>
 <dd>If the referent is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, this is the <a href="/en-US/docs/Mozilla/Projects/SpiderMonkey/SavedFrame" title="SavedFrame">JavaScript execution stack</a> captured at the time of the promise’s allocation. This can return null if the promise was not created from script. If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, throw a <code>TypeError</code> exception.</dd>
 <dt><code>promiseResolutionSite</code></dt>
 <dd>If the referent is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, this is the <a href="/en-US/docs/Mozilla/Projects/SpiderMonkey/SavedFrame" title="SavedFrame">JavaScript execution stack</a> captured at the time of the promise’s resolution. This can return null if the promise was not resolved by calling its <code>resolve</code> or <code>reject</code> resolving functions from script. If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, throw a <code>TypeError</code> exception.</dd>
 <dt><code>promiseID</code></dt>
 <dd>If the referent is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, this is a process-unique identifier for the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>. With e10s, the same id can potentially be assigned to multiple <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> instances, if those instances were created in different processes. If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, throw a <code>TypeError</code> exception.</dd>
 <dt><code>promiseDependentPromises</code></dt>
 <dd>If the referent is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, this is an <code>Array</code> of <code>Debugger.Objects</code> referring to the promises directly depending on the referent <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>. These are:</dd>
</dl>

<ol style="list-style-type: decimal;">
 <li>Return values of <code>then()</code> calls on the promise.</li>
 <li>Return values of <code>Promise.all()</code> if the referent <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> was passed in as one of the arguments.</li>
 <li>Return values of <code>Promise.race()</code> if the referent <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> was passed in as one of the arguments.</li>
</ol>

<p>Once a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> is settled, it will generally notify its dependent promises and forget about them, so this is most useful on <em>pending</em> promises.</p>

<p>Note that the <code>Array</code> only contains the promises that directly depend on the referent <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>. It does not contain promises that depend on promises that depend on the referent <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>.</p>

<p>If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, throw a <code>TypeError</code> exception.</p>

<dl>
 <dt><code>promiseLifetime</code></dt>
 <dd>If the referent is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, this is the number of milliseconds elapsed since the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> was created. If the referent is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, throw a <code>TypeError</code> exception.</dd>
 <dt><code>promiseTimeToResolution</code></dt>
 <dd>If the referent is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, this is the number of milliseconds elapsed between when the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a> was created and when it was resolved. If the referent hasn’t been resolved or is not a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="Promise"><code>Promise</code></a>, throw a <code>TypeError</code> exception.</dd>
 <dt><code>global</code></dt>
 <dd>A <code>Debugger.Object</code> instance referring to the global object in whose scope the referent was allocated. This does not unwrap cross-compartment wrappers: if the referent is a wrapper, the result refers to the wrapper’s global, not the wrapped object’s global. The result refers to the global directly, not via a wrapper.</dd>
 <dt><code id="allocationsite">allocationSite</code></dt>
 <dd>If <a href="Debugger.Memory#trackingallocationsites" title="Debugger.Memory: trackingAllocationSites">object allocation site tracking</a> was enabled when this <code>Debugger.Object</code>’s referent was allocated, return the <a href="/en-US/docs/Mozilla/Projects/SpiderMonkey/SavedFrame" title="SavedFrame">JavaScript execution stack</a> captured at the time of the allocation. Otherwise, return <code>null</code>.</dd>
</dl>

<h2 id="Function_Properties_of_the_Debugger.Object_prototype">Function Properties of the Debugger.Object prototype</h2>

<p>The functions described below may only be called with a <code>this</code> value referring to a <code>Debugger.Object</code> instance; they may not be used as methods of other kinds of objects. The descriptions use “referent” to mean “the referent of this <code>Debugger.Object</code> instance”.</p>

<p>Unless otherwise specified, these methods are not <a href="Debugger.Frame#invf" title="Debugger.Frame: Invocation Frames">invocation functions</a>; if a call would cause debuggee code to run (say, because it gets or sets an accessor property whose handler is debuggee code, or because the referent is a proxy whose traps are debuggee code), the call throws a <a href="Conventions#the-debugger.debuggeewouldrun-exception" title="Debugger API: DebuggeeWouldRun"><code>Debugger.DebuggeeWouldRun</code></a> exception.</p>

<p>These methods may throw if the referent is not a native object. Even simple accessors like <code>isExtensible</code> may throw if the referent is a proxy or some sort of exotic object like an opaque wrapper.</p>

<dl>
 <dt><code>getProperty(<em>key</em>, [<em>receiver</em>])</code></dt>
 <dd>Return a completion value with "return" being the value of the referent's property named <em>key</em>, or <code>undefined</code> if it has no such property. <em>key</em> must be a string or symbol; <em>receiver</em> must be a debuggee value. If the property is a getter, it will be evaluated with <em>receiver</em> as the receiver, defaulting to the <code>Debugger.Object</code> if omitted.</dd>
 <dt><code>setProperty(<em>key</em>, <em>value</em>, [<em>receiver</em>])</code></dt>
 <dd>Store <em>value</em> as the value of the referent’s property named <em>key</em>, creating the property if it does not exist. <em>key</em> must be a string or symbol; <em>value</em> and <em>receiver</em> must be debuggee values. If the property is a setter, it will be evaluated with <em>receiver</em> as the receiver, defaulting to the <code>Debugger.Object</code> if omitted.</dd>
 <dt><code>getOwnPropertyDescriptor(<em>name</em>)</code></dt>
 <dd>Return a property descriptor for the property named<em>name</em> of the referent. If the referent has no such property, return <code>undefined</code>. (This function behaves like the standard <code>Object.getOwnPropertyDescriptor</code> function, except that the object being inspected is implicit; the property descriptor returned is allocated as if by code scoped to the debugger’s global object (and is thus in the debugger’s compartment); and its <code>value</code>, <code>get</code>, and <code>set</code> properties, if present, are debuggee values.)</dd>
 <dt><code>getOwnPropertyNames()</code></dt>
 <dd>Return an array of strings naming all the referent’s own properties, as if <code>Object.getOwnPropertyNames(<em>referent</em>)</code> had been called in the debuggee, and the result copied in the scope of the debugger’s global object.</dd>
 <dt><code>getOwnPropertySymbols()</code></dt>
 <dd>Return an array of strings naming all the referent’s own symbols, as if <code>Object.getOwnPropertySymbols(<em>referent</em>)</code> had been called in the debuggee, and the result copied in the scope of the debugger’s global object.</dd>
 <dt><code>defineProperty(<em>name</em>,<em>attributes</em>)</code></dt>
 <dd>Define a property on the referent named<em>name</em>, as described by the property descriptor<em>descriptor</em>. Any <code>value</code>, <code>get</code>, and <code>set</code> properties of<em>attributes</em> must be debuggee values. (This function behaves like <code>Object.defineProperty</code>, except that the target object is implicit, and in a different compartment from the function and descriptor.)</dd>
 <dt><code>defineProperties(<em>properties</em>)</code></dt>
 <dd>Add the properties given by<em>properties</em> to the referent. (This function behaves like <code>Object.defineProperties</code>, except that the target object is implicit, and in a different compartment from the<em>properties</em> argument.)</dd>
 <dt><code>deleteProperty(<em>name</em>)</code></dt>
 <dd>Remove the referent’s property named<em>name</em>. Return true if the property was successfully removed, or if the referent has no such property. Return false if the property is non-configurable.</dd>
 <dt><code>seal()</code></dt>
 <dd>Prevent properties from being added to or deleted from the referent. Return this <code>Debugger.Object</code> instance. (This function behaves like the standard <code>Object.seal</code> function, except that the object to be sealed is implicit and in a different compartment from the caller.)</dd>
 <dt><code>freeze()</code></dt>
 <dd>Prevent properties from being added to or deleted from the referent, and mark each property as non-writable. Return this <code>Debugger.Object</code> instance. (This function behaves like the standard <code>Object.freeze</code> function, except that the object to be sealed is implicit and in a different compartment from the caller.)</dd>
 <dt><code>preventExtensions()</code></dt>
 <dd>Prevent properties from being added to the referent. (This function behaves like the standard <code>Object.preventExtensions</code> function, except that the object to operate on is implicit and in a different compartment from the caller.)</dd>
 <dt><code>isSealed()</code></dt>
 <dd>Return true if the referent is sealed—that is, if it is not extensible, and all its properties have been marked as non-configurable. (This function behaves like the standard <code>Object.isSealed</code> function, except that the object inspected is implicit and in a different compartment from the caller.)</dd>
 <dt><code>isFrozen()</code></dt>
 <dd>Return true if the referent is frozen—that is, if it is not extensible, and all its properties have been marked as non-configurable and read-only. (This function behaves like the standard <code>Object.isFrozen</code> function, except that the object inspected is implicit and in a different compartment from the caller.)</dd>
 <dt><code>isExtensible()</code></dt>
 <dd>Return true if the referent is extensible—that is, if it can have new properties defined on it. (This function behaves like the standard <code>Object.isExtensible</code> function, except that the object inspected is implicit and in a different compartment from the caller.)</dd>
 <dt><code>copy(<em>value</em>)</code></dt>
 <dd>
 <p>Apply the HTML5 “structured cloning” algorithm to create a copy of<em>value</em> in the referent’s global object (and thus in the referent’s compartment), and return a <code>Debugger.Object</code> instance referring to the copy.</p>

 <p>Note that this returns primitive values unchanged. This means you can use <code>Debugger.Object.prototype.copy</code> as a generic “debugger value to debuggee value” conversion function—within the limitations of the “structured cloning” algorithm.</p>
 </dd>
 <dt><code>create(<em>prototype</em>, [<em>properties</em>])</code></dt>
 <dd>Create a new object in the referent’s global (and thus in the referent’s compartment), and return a <code>Debugger.Object</code> referring to it. The new object’s prototype is<em>prototype</em>, which must be an <code>Debugger.Object</code> instance. The new object’s properties are as given by<em>properties</em>, as if<em>properties</em> were passed to <code>Debugger.Object.prototype.defineProperties</code>, with the new <code>Debugger.Object</code> instance as the <code>this</code> value.</dd>
 <dt><code>makeDebuggeeValue(<em>value</em>)</code></dt>
 <dd>
 <p>Return the debuggee value that represents<em>value</em> in the debuggee. If<em>value</em> is a primitive, we return it unchanged; if<em>value</em> is an object, we return the <code>Debugger.Object</code> instance representing that object, wrapped appropriately for use in this <code>Debugger.Object</code>’s referent’s compartment.</p>

 <p>Note that, if<em>value</em> is an object, it need not be one allocated in a debuggee global, nor even a debuggee compartment; it can be any object the debugger wishes to use as a debuggee value.</p>

 <p>As described above, each <code>Debugger.Object</code> instance presents its referent as viewed from a particular compartment. Given a <code>Debugger.Object</code> instance<em>d</em> and an object<em>o</em>, the call <code><em>d</em>.makeDebuggeeValue(<em>o</em>)</code> returns a <code>Debugger.Object</code> instance that presents<em>o</em> as it would be seen by code in<em>d</em>’s compartment.</p>
 </dd>
 <dt><code>decompile([<em>pretty</em>])</code></dt>
 <dd>If the referent is a function that is debuggee code, return the JavaScript source code for a function definition equivalent to the referent function in its effect and result, as a string. If<em>pretty</em> is present and true, produce indented code with line breaks. If the referent is not a function that is debuggee code, return <code>undefined</code>.</dd>
 <dt><code>call(<em>this</em>,<em>argument</em>, …)</code></dt>
 <dd>If the referent is callable, call it with the given<em>this</em> value and<em>argument</em> values, and return a <a href="Conventions#completion-values" title="Debugger API: General Conventions: Completion Values">completion value</a> describing how the call completed.<em>This</em> should be a debuggee value, or <code>{ asConstructor: true }</code> to invoke the referent as a constructor, in which case SpiderMonkey provides an appropriate <code>this</code> value itself. Each<em>argument</em> must be a debuggee value. All extant handler methods, breakpoints, and so on remain active during the call. If the referent is not callable, throw a <code>TypeError</code>. This function follows the <a href="Debugger.Frame#invf" title="Debugger.Frame: Invocation Frames">invocation function conventions</a>.</dd>
 <dt><code>apply(<em>this</em>,<em>arguments</em>)</code></dt>
 <dd>If the referent is callable, call it with the given<em>this</em> value and the argument values in<em>arguments</em>, and return a <a href="Conventions#completion-values" title="Debugger API: General Conventions: Completion Values">completion value</a> describing how the call completed.<em>This</em> should be a debuggee value, or <code>{ asConstructor: true }</code> to invoke<em>function</em> as a constructor, in which case SpiderMonkey provides an appropriate <code>this</code> value itself.<em>Arguments</em> must either be an array (in the debugger) of debuggee values, or <code>null</code> or <code>undefined</code>, which are treated as an empty array. All extant handler methods, breakpoints, and so on remain active during the call. If the referent is not callable, throw a <code>TypeError</code>. This function follows the <a href="Debugger.Frame#invf" title="Debugger.Frame: Invocation Frames">invocation function conventions</a>.</dd>
 <dt><code>executeInGlobal(<em>code</em>, [<em>options</em>])</code></dt>
 <dd>
 <p>If the referent is a global object, evaluate<em>code</em> in that global environment, and return a <a href="Conventions#completion-values" title="Debugger API: General Conventions: Completion Values">completion value</a> describing how it completed.<em>Code</em> is a string. All extant handler methods, breakpoints, and so on remain active during the call. This function follows the <a href="Debugger.Frame#invf" title="Debugger.Frame: Invocation Frames">invocation function conventions</a>. If the referent is not a global object, throw a <code>TypeError</code> exception.</p>

 <p><em>Code</em>is interpreted as strict mode code when it contains a Use Strict Directive.</p>

 <p>This evaluation is semantically equivalent to executing statements at the global level, not an indirect eval. Regardless of<em>code</em> being strict mode code, variable declarations in<em>code</em> affect the referent global object.</p>

 <p>The<em>options</em> argument is as for <a href="Debugger.Frame#eval" title="Debugger.Frame: Eval"><code>Debugger.Frame.prototype.eval</code></a>.</p>
 </dd>
 <dt><code>executeInGlobalWithBindings(<em>code</em>,<em>bindings</em>, [<em>options</em>])</code></dt>
 <dd>
 <p>Like <code>executeInGlobal</code>, but evaluate<em>code</em> using the referent as the variable object, but with a lexical environment extended with bindings from the object<em>bindings</em>. For each own enumerable property of<em>bindings</em> named<em>name</em> whose value is<em>value</em>, include a variable in the lexical environment in which<em>code</em> is evaluated named<em>name</em>, whose value is<em>value</em>. Each<em>value</em> must be a debuggee value. (This is not like a <code>with</code> statement:<em>code</em> may access, assign to, and delete the introduced bindings without having any effect on the<em>bindings</em> object.)</p>

 <p>This method allows debugger code to introduce temporary bindings that are visible to the given debuggee code and which refer to debugger-held debuggee values, and do so without mutating any existing debuggee environment.</p>

 <p>Note that, like <code>executeInGlobal</code>, any declarations it contains affect the referent global object, even as<em>code</em> is evaluated in an environment extended according to<em>bindings</em>. (In the terms used by the ECMAScript specification, the <code>VariableEnvironment</code> of the execution context for<em>code</em> is the referent, and the<em>bindings</em> appear in a new declarative environment, which is the eval code’s <code>LexicalEnvironment</code>.)</p>

 <p>The<em>options</em> argument is as for <a href="Debugger.Frame#eval" title="Debugger.Frame: Eval"><code>Debugger.Frame.prototype.eval</code></a>.</p>
 </dd>
 <dt><code>asEnvironment()</code></dt>
 <dd>If the referent is a global object, return the <a href="Debugger.Environment"><code>Debugger.Environment</code></a> instance representing the referent’s global lexical scope. The global lexical scope’s enclosing scope is the global object. If the referent is not a global object, throw a <code>TypeError</code>.</dd>
 <dt><code>unwrap()</code></dt>
 <dd>If the referent is a wrapper that this <code>Debugger.Object</code>’s compartment is permitted to unwrap, return a <code>Debugger.Object</code> instance referring to the wrapped object. If we are not permitted to unwrap the referent, return <code>null</code>. If the referent is not a wrapper, return this <code>Debugger.Object</code> instance unchanged.</dd>
 <dt><code>unsafeDereference()</code></dt>
 <dd>
 <p>Return the referent of this <code>Debugger.Object</code> instance.</p>

 <p>If the referent is an inner object (say, an HTML5 <code>Window</code> object), return the corresponding outer object (say, the HTML5 <code>WindowProxy</code> object). This makes <code>unsafeDereference</code> more useful in producing values appropriate for direct use by debuggee code, without using <a href="Debugger.Frame#invf" title="Debugger.Frame: Invocation Frames">invocation functions</a>.</p>

 <p>This method pierces the membrane of <code>Debugger.Object</code> instances meant to protect debugger code from debuggee code, and allows debugger code to access debuggee objects through the standard cross-compartment wrappers, rather than via <code>Debugger.Object</code>’s reflection-oriented interfaces. This method makes it easier to gradually adapt large code bases to this Debugger API: adapted portions of the code can use <code>Debugger.Object</code> instances, but use this method to pass direct object references to code that has not yet been updated.</p>
 </dd>
 <dt><code>forceLexicalInitializationByName(<em>binding</em>)</code></dt>
 <dd>If<em>binding</em> is in an uninitialized state initialize it to undefined and return true, otherwise do nothing and return false.</dd>
</dl>

<h4 id="Source_Metadata">Source Metadata</h4>

<dl>
 <dt>Generated from file:</dt>
 <dt> </dt>
 <dd>js/src/doc/Debugger/Debugger.Object.md</dd>
 <dt>Watermark:</dt>
 <dd id="watermark">sha256:7ae16a834e0883a95b4e0d227193293f6b6e4e4dd812c2570372a39c4c04897b</dd>
 <dt>Changeset:</dt>
 <dd><a href="https://hg.mozilla.org/mozilla-central/rev/5572465c08a9">5572465c08a9+</a></dd>
</dl>
